
.include "m8def.inc"	;AT8-16, 4,  20


.org 0				; 
	rjmp start
.org 1				; int0
	rjmp datchik1
.org 2				; int1
	rjmp datchik2
.org 6				;Output Compare1A Interrupt Vector Address
	rjmp timer1compare
.org 8				; timer1
	rjmp timer1
.org 14				;. 
	rjmp adc_complete;  ( )


start:
;====================
ldi R16, low(RAMEND) ; 
out SPL, R16 
ldi R16, high(RAMEND); 
out SPH, R16
;==== ====
ldi R16, 0b00000011
out ddrC, R16		;P
ldi R16, 0b11111100
out PortC, R16		; 
ldi R16, 0b11010010
out ddrD, R16		;PD0-RXD;PD1-TXD;PD2,PD3-signal;PD4-Flyback
ldi R16, 0b00101101
out PortD, R16		; 
ldi R16, 0b00000100
out ddrB, R16		;PB
ldi R16, 0b11111011
out PortB, R16		; 
;================
clr R0				; 
clr R1				; 
clr R2				;"0", 
ldi R16,15
mov R4,R16			;,  
clr R5				;   x%
clr R6				;   x%
clr R7				;OCR1AH
clr R8				;OCR1AL,
clr R9				;TCNT1H
clr R10				;TCNT1L,1
clr R11				;TCNT1H
clr R12				;TCNT1L,2
clr R13				;H
clr R14				;L,.
clr R15				; sreg,
clr R16
clr R17
clr R18
ldi R20,0b10000000	; 
clr R21				;    
ldi R22,242			;
ldi R23,160			; ,0.7, 160=112
clr R25				;   
clr R26				; "lowX", ,LD
clr R27				;POH "highX", ,LD
clr R28				;  
clr R29				; ""
ldi R30,0b00000010	; 
;===  ===
rcall FuozTable1
rcall FuozTable2
rcall FuozTable3	;   
;   
ldi R27,1
ldi R26,53		; 01-53
st X+,R2		;53,clr
st X+,R2		;54,clr
st X,R2			;55,clr
;    
;R16-[0..+2],R17-
ldi R16,0		;[ROM-000..002]
sbrc R30, 1		;if pinX,n='1' then do
rcall readflash	; ,
sbrc R30, 1		;if pinX,n='1' then do
mov R23,R17		; 
;========Timer=======
ldi R16, 0b00000010	; 8,   4
out TCCR1B, R16 	;  16-
ldi R16, 0b00010100
out TIMSK, R16 		; 16- 
;=================
ldi R16, 0b01100010	;AD_Converter ADMUX byte
out ADMUX, R16
ldi R16, 0b10001101	;AD_Converter ADCSRA byte,125kHz
out ADCSRA, R16		;   800, 416
;=== ===
ldi R16, 0b11000000
out GICR, R16		;.  int0,int1
ldi R16, 0b00001010
out MCUCR, R16		;   
sei 				;.   
;==  ,   ==
//////////////////////////////////////////////////////////
;  ,20
;R20/7- , 16- 
;R20/6-  ,"" 
;R20/5-  1,  
;R20/4-  ,. 
;R20/3-  ""  0x1FF
;R20/2-  2,  
;R20/1-,, 
//////////////////////////////////////////////////////////
;  ,30
;R30/2-  , [1-,0-]
;R30/1-, [1-,0-]
;R30/0- ,[1-,0-]
//////////////////////////////////////////////////////////
main:
;    flyback(6mks/1)
;      
sbis PinD,7		;    "0"
inc R28			;+1
cpi R28, 17		;100mks,
brlo main2		; 
;   ""
cbi PortC,0		;"0"  ""
cpi R28, 100	;600mks,flyback
brlo main2		; 
;  ."flyback"
sbi PortD,7		;"1"  "flyback"
clr R28			; 
ori R30, 0b00000001;sbiR30/0, 
main2:


; ""  
sbrc R20, 6		;if pinX,n='1' then do
inc R29			;+1
cpi R29, 20		;120mks,
brlo main3
andi R20, 0b10111111;cbiR20/6, 
clr R29			; 
main3:


;   
;    
;  
sbrs R30, 0		;if pinX,n='0' then do
rjmp main4		; ,.
sbrc R30, 2		;if pinX,n='1' then do
rcall eeprom_metki;  
sbrc R30, 1		;if pinX,n='1' then do
rcall dlina_metki;  
main4:


sbrs R20, 5		;if pinX,n='0' then do
rjmp main
sbrc R20, 7		;if pinX,n='1' then do
rcall holostie	;,   460/
rcall norm		; ,1
rjmp main
nop
nop
nop
;-------------------------------------------------------------
;----------------  --------------------
;-------------------------------------------------------------
;== 16- ==
;      480/
timer1:
in R15,SREG		; SREG
ori R20, 0b10000000	;sbiR20/7, 
out SREG,R15	; SREG
reti


;=  OCR1A, 16- =
;,   
timer1compare:
in R15,SREG		; SREG
sbrs R20, 4		;if pinX,n='0' then do
reti
ori R20, 0b01000000	;sbiR20/6,
cbi PortD,7		;"0"  "flyback"
sbi PortC,0		;"1"  ""
andi R20, 0b11101111;cbiR20/4,
out SREG,R15	; SREG
reti


;===  ===
datchik1:
in R15,SREG		; SREG
sbrc R20, 6		;if pinX,n='1' then do
rjmp d1propusk	;,.
in R10, TCNT1L
in R9, TCNT1H	;  
out TCNT1H, R2	;R2=0
out TCNT1L, R2	; 
ori R20, 0b00100000	;sbiR20/5, 
;  ,  
;     
sbrs R20, 4		;if pinX,n='0' then do
rjmp d1propusk	; .,.
;    
ori R20, 0b01000000	;sbiR20/6,
cbi PortD,7		;"0"  "flyback"
sbi PortC,0		;"1"  ""
andi R20, 0b11101111;cbiR20/4,
d1propusk:
out SREG,R15	; SREG
reti

;===  ===
datchik2:
in R15,SREG		; SREG
sbrc R20, 6		;if pinX,n='1' then do
rjmp d2propusk	;,.
in R12, TCNT1L
in R11, TCNT1H	;  
ori R20, 0b00000100	;sbiR20/2,
;  , 
;    
d2propusk:
ldi R27,1
ldi R26,53		; 01-53
st X,R2			; 
out SREG,R15	; SREG
reti


;====  ====
adc_complete:
in R4, ADCL	
in R4, ADCH
lsr R4			;1/2=128
lsr R4			;1/2=64
lsr R4			;1/2=32
ori R20, 0b00000010;sbiR20/1,,
reti


;==== =====
;=  =
norm:
mov R21, R9		;   16-,Hbyte
com R21			; 
;  255   ,
;  -  ,  - 
;     
;   ,  
///////////////////////////////////////////////////
cpi R21, 242	;   
brsh rpm19k5	;   
cpi R21, 241	;   
brsh rpm16k7	;   
cpi R21, 240	;   
brsh rpm14k6	;   
cpi R21, 239	;   
brsh rpm13k		;   
cpi R21, 238	;   
brsh rpm11k7	;   
cpi R21, 237	;   
brsh rpm10k6	;   
cpi R21, 236	;   
brsh rpm9k7		;   
cpi R21, 234	;   
brsh rpm9k		;   
cpi R21, 232	;   
brsh rpm8k3		;   
cpi R21, 230	;   
brsh rpm7k8		;   
cpi R21, 227	;   
brsh rpm7k3		;   
cpi R21, 225	;   
brsh rpm6k9		;   
cpi R21, 222	;   
brsh rpm6k5		;   
cpi R21, 219	;   
brsh rpm6k1		;   
cpi R21, 216	;   
brsh rpm5k6		;   
cpi R21, 213	;   
brsh rpm5k1		;   
cpi R21, 208	;   
brsh rpm4k7		;   
cpi R21, 202	;   
brsh rpm4k2		;   
cpi R21, 197	;   
brsh rpm3k9		;   
cpi R21, 190	;   
brsh rpm3k5		;   
cpi R21, 182	;   
brsh rpm3k		;   
cpi R21, 177	;   
brsh rpm2k8		;   
cpi R21, 171	;   
brsh rpm2k5		;   
cpi R21, 165	;   
brsh rpm2k2		;   
cpi R21, 157	;   
brsh rpm2k		;   
cpi R21, 148	;   
brsh rpm1k8		;   
cpi R21, 138	;   
brsh rpm1k5		;   
cpi R21, 125	;   
brsh rpm1k2		;   
cpi R21, 109	;   
brsh rpm1k		;   
cpi R21, 88	;   
brsh rpm0k8		;   
cpi R21, 60	;   
brsh rpm0k6		;   
clr R26			; 500   /
rjmp RpmEnd		; 32
////////////////////////////////////////////////////////
rpm19k5:		;
ldi R26, 0x1F	;   "low"
rjmp RpmEnd		; ""
rpm16k7:
ldi R26, 0x1E
rjmp RpmEnd
rpm14k6:
ldi R26, 0x1D
rjmp RpmEnd
rpm13k:
ldi R26, 0x1C
rjmp RpmEnd
rpm11k7:
ldi R26, 0x1B
rjmp RpmEnd
rpm10k6:
ldi R26, 0x1A
rjmp RpmEnd
rpm9k7:
ldi R26, 0x19
rjmp RpmEnd
rpm9k:
ldi R26, 0x18
rjmp RpmEnd
rpm8k3:
ldi R26, 0x17
rjmp RpmEnd
rpm7k8:
ldi R26, 0x16
rjmp RpmEnd
rpm7k3:
ldi R26, 0x15
rjmp RpmEnd
rpm6k9:
ldi R26, 0x14
rjmp RpmEnd
rpm6k5:
ldi R26, 0x13
rjmp RpmEnd
rpm6k1:
ldi R26, 0x12
rjmp RpmEnd
rpm5k6:
ldi R26, 0x11
rjmp RpmEnd
rpm5k1:
ldi R26, 0x10
rjmp RpmEnd
rpm4k7:
ldi R26, 0x0F
rjmp RpmEnd
rpm4k2:
ldi R26, 0x0E
rjmp RpmEnd
rpm3k9:
ldi R26, 0x0D
rjmp RpmEnd
rpm3k5:
ldi R26, 0x0C
rjmp RpmEnd
rpm3k:
ldi R26, 0x0B
rjmp RpmEnd
rpm2k8:
ldi R26, 0x0A
rjmp RpmEnd
rpm2k5:
ldi R26, 0x09
rjmp RpmEnd
rpm2k2:
ldi R26, 0x08
rjmp RpmEnd
rpm2k:
ldi R26, 0x07
rjmp RpmEnd
rpm1k8:
ldi R26, 0x06
rjmp RpmEnd
rpm1k5:
ldi R26, 0x05
rjmp RpmEnd
rpm1k2:
ldi R26, 0x04
rjmp RpmEnd
rpm1k:
ldi R26, 0x03
rjmp RpmEnd
rpm0k8:
ldi R26, 0x02
rjmp RpmEnd
rpm0k6:
ldi R26, 0x01
;  "low" 
;  00100-0011F,32
RpmEnd:

;    "0"
;   
ldi R27, 1		; "highX"1
sbis PinC,5		;    "0"
ldi R27, 2		; "highX"2
sbis PinC,4		;    "0"
ldi R27, 3		; "highX"3
;  "High" ,  
ld R25, X		;  -R27:26   25


; :
;sbi ADCSRA,6	;  
;sbrs R20, 1		;if pinX,n='0' then do
;rjmp ADC_negotov
;mov R17,R4		; 
;andi R20, 0b11111101;cbiR20/1,
;ADC_negotov:
; 
;cpi R17,16		; 
;brlo adc_plus	; 
;;adc_minus:
;mov R16,R17
;subi R16,16		;0...15
;sub R25,R16		;""  
;rjmp adc_exit	;
;adc_plus:
;ldi R16,15
;sub R16,R17		;,0...15
;add R25,R16		;""  
;adc_exit:


;  
cp R25,R23		;.  
brlo pervii		; .,1
cpi R25, 180	; >=180
brsh pervii		; ""
andi R20, 0b11111011;cbiR20/2,
sbi PortB,2		;test led indicator
vtoroi:			;   
sbrc R20, 7		;if pinX,n='1' then do
rjmp err2		;,.
sbrs R20, 2		;if pinX,n='0' then do
rjmp vtoroi		; 
cp R25,R23		; 
brne noiskr
rjmp iskra		;  
noiskr:			; 
sub R25,R23		;"."-""
;   "", ..
mov R16,R9		; 
mov R17,R10		;
rcall matematika;R16R17*R25=R7R8
add R8,R12
adc R7,R11		;+. 
;  R7R8  
;    
out OCR1AH, R7	;HighByte
out OCR1AL, R8	;LowByte
ori R20, 0b00010000	;sbiR20/4,
andi R20, 0b11010011;cbiR20/532,
ret
err2:			;  
ldi R27,1
ldi R26,53		; 01-53
ld R16,X		;53
inc R16
cpi R16,3
brlo err3		;   
ldi R23,160		; ,0.7, 160=112
err3:
st X,R16		;53,
ori R30, 0b00000100;sbiR30/2,
andi R20, 0b11010011;cbiR20/532,
ret


pervii:			;   
cbi PortB,2		;test led indicator

;  
;   .
mov R6,R10		; 
mov R5,R9		; .
cp R10,R14		;  
cpc R9,R13		; .
breq rovno		; , 
brlo razgon
;
sub R6,R14
sbc R5,R13
lsr R5
ror R6			;1/2  .
add R6,R10
adc R5,R9
brvc rovno		; 
ser R16			;=0xFF
mov R6,R16		; 
mov R5,R16		;.
rjmp rovno
razgon:			; 
sub R14,R6
sbc R13,R5
lsr R13
ror R14			;1/2  .
sub R6,R14
sbc R5,R13
rovno:
mov R14,R10
mov R13,R9
;R5:R6- 180
;R9:R10-
;R13:R14-

;   , 
;   4
;     ,20
cpi R25, 2		;"min"
brlo iskra		;  "0..1",  
cp R25, R22		;"max"
brsh iskra		;  "255",  


ldi R22,242		;,
;    180,=126
;    
;     
cpi R25, 180	;180*0.7=126
brlo raschet	; ,    
breq propusk	; ,  
;   
sbrs R20, 3		;if pinX,n='0' then do
rcall iskra		; ,
ldi R22,243		;,
;  "", ..
mov R16,R5		; 
mov R17,R6		;
com R25			; 
rcall matematika;R16R17*R25=R7R8
sub R6,R8		;" "-R7R8
sbc R5,R7
;  R5R6  
;     
out OCR1AH, R5	;HighByte
out OCR1AL, R6	;LowByte
ori R20, 0b00011000	;sbiR20/43,
andi R20, 0b11011111;cbiR20/5,
ret

raschet:
;  "", ..
mov R16,R9		; 
mov R17,R10		;
rcall matematika;R16R17*R25=R7R8
;  R7R8  
;      
out OCR1AH, R7	;HighByte
out OCR1AL, R8	;LowByte
ori R20, 0b00010000	;sbiR20/4,
andi R20, 0b11010111;cbiR20/53,
ret


;  
;R16R17*R25=R7R8
matematika:
lsr R16			;1/2, 
ror R17			; 360/512=0.7
mul R16,R25		;  
mov R8,R0
mov R7,R1
mul R17,R25		;  
add R8,R1
adc R7,R2		;R2=0
ret


; , "" 
propusk:
andi R20, 0b11010111;cbiR20/53,
ret


;======  ,   =======
;      
;       
iskra:
ori R20, 0b01000000	;sbiR20/6,
sbrs R20, 3		;if pinX,n='0' then do
cbi PortD,7		;"0"  "flyback"
sbrs R20, 3		;if pinX,n='0' then do
sbi PortC,0		;"1"  ""
ldi R22,242		;,,1 
andi R20, 0b11010111;cbiR20/53,
ret


;==() ==
;    
;    460/
;    
;      
; ,  
holostie:
ser R16			;=0xFF
mov R9, R16		;  480/
mov R10, R16	; .1
mov R13, R16	;.2
mov R14, R16	;.2
andi R20, 0b01111111;cbiR20/7, 
ret



;   
;    
;  
dlina_metki:
; 
cpi R21,177		; 
brsh metka_end2 ; 1.5,
cpi R21,157		; 1.2,
brlo metka_end2	;,
;  
ldi R27,1
ldi R26,54		; 01-54
ld R16,X		;54
inc R16			;+1
cpi R16,20
brsh metka2		;  
st X,R16		;54
rjmp metka_end2	;,
metka2:			; 
st X,R2			;54,clr 
;R9:R10-.
;R11:R12-.
;R11R12/R9=R18, 
mov R16,R11
mov R17,R12
lsl R16			;*2, 
rol R17			;  0.7
clr R18			;
cp R16,R2
cpc R17,R2		;  
breq metka_end2	;   
minus:			;    
cp R17,R9		; 
cpc R16,R2		;  
brlo exit		;  ,  
sub R17,R9		;    
sbc R16,R2		;   
inc R18			;+1  
rjmp minus		;   
exit:			;   
cpi R18,6		;     4
brlo metka_end2	;  
cpi R18,172		;     120
brsh metka_end2	;  
ldi R27,1
ldi R26,50		; 01-50
ld R17,X+		;  ,50
ld R16,X+		;51
st X,R16		;52
st -X,R17		;51
st -X,R18		;50
cp R18,R17
cpc R18,R16
brne metka_end2	; ,.
;, 
cp R23,R18
breq metka_end	; 
brsh metka_max	; 
;  
dec R18			;
cp R23,R18		;  1
breq metka_end	;
dec R18			;
cp R23,R18		;  2
breq metka_end	;
rjmp metka_write; 
metka_max:		;  
inc R18			;
cp R23,R18		;  1
breq metka_end	;
inc R18			;
cp R23,R18		;  2
breq metka_end	;
metka_write:	;  
mov R23,R17		;  
ori R30, 0b00000100;sbiR30/2,
metka_end:		;  
andi R30, 0b11111101;cbiR30/1,
metka_end2:
andi R30, 0b11111110;cbiR30/0,
ret



;    
;  8.5/
;R16-[01-55],R17-
eeprom_metki:
; 
cpi R21,177		; 
brsh metka_end2 ; 1.5,
;   
ldi R27,1
ldi R26,55		; 01-55
ld R16,X		;-
cpi R16,9
brsh eeprom_end
cpi R16,6
brsh ROM_06
cpi R16,4
brsh ROM_04
cpi R16,3
brsh ROM_03
;ROM_0:
mov R17,R23		;
rcall saveflash;[ROM-00..02]
inc R16			; ROM+1
st X,R16		;55
rjmp metka_end2	;.

ROM_03:
;   
;R16-[0..+2],R17-
;+1[01-56..57]
ldi R16,3		;[ROM-003..005]
rcall readflash	;HighByte
ldi R27,1
ldi R26,56		; 01-56
st X,R17		;56
ldi R16,6		;[ROM-006..008]
rcall readflash	;LowByte
ld R18,X		;56
ldi R16,1		; 
add R17,R16		; +1
adc R18,R2		;R2=0
st X+,R18		;56,HByte
st X,R17		;57,LByte
ldi R16,3		;,HByte
ROM_04:
ldi R27,1
ldi R26,56		; 01-56
ld R17,X		;56
rcall saveflash;[ROM-03..05]
inc R16			; ROM+1
ldi R26,55		; 01-55
st X,R16		;55
rjmp metka_end2	;.

ROM_06:
ldi R27,1
ldi R26,57		; 01-56
ld R17,X		;56
rcall saveflash;[ROM-06..08]
inc R16			; ROM+1
ldi R26,55		; 01-55
st X,R16		;55
rjmp metka_end2	;.

eeprom_end:
; ,  
andi R30, 0b11111000;cbiR30/210,
ret



;==== ====
;R16-,R17-
saveflash:
sbic eecr,1		;    "1"
rjmp saveflash	;  
out eearh,R2	; ,R2=0
out eearl,R16	; 
out eedr,R17	;(L)
sbi eecr,2		;eemwe,
sbi eecr,1		;eewe, 
ret
;======== ===========
;R16-[0..+2],R17,R18-
readflash:
sbic eecr,1		;    "1"
rjmp readflash	;  
out eearh,R2	; ,R2=0
out eearl,R16	; 
sbi eecr,0		;eere,
in R17,eedr		;(L)
inc R16			;+1
readflash2:
sbic eecr,1		;    "1"
rjmp readflash2	;  
out eearl,R16	; 
sbi eecr,0		;eere,
in R18,eedr		;(L)
cp R17,R18		; 
breq readcurrect
inc R16			;  
readflash3:		; 
sbic eecr,1		;    "1"
rjmp readflash3	;  
out eearl,R16	; 
sbi eecr,0		;eere,
in R16,eedr		;(L)
cp R17,R16		; 
breq readcurrect
mov R17,R18		; 
readcurrect:
ret

//////////////////////////////////////////////////
//////////////////////////////////////////////////

;== 1,   ==
;=======  20,  0.7=======
FuozTable1:
ldi R27, 0x01	; "highX"=01
ldi R26, 0x00	; "lowX"=00
;  
;500  , /
ldi R16, 30	;
st X+, R16	; , -1
;600 /
ldi R16, 28	;
st X+, R16	; , 0,4
;800 /
ldi R16, 27	;
st X+, R16	; , 1,1
;1000 /
ldi R16, 26	;
st X+, R16	; , 1,8
;1200 /
ldi R16, 24	;
st X+, R16	; , 3,2
;1500 /
ldi R16, 21	;
st X+, R16	; , 5,3
;1800 /
ldi R16, 20	;
st X+, R16	; , 6
;2000 /
ldi R16, 18	;
st X+, R16	; , 7,4
;2200 /
ldi R16, 18	;
st X+, R16	; , 7,4
;2500 /
ldi R16, 17	;
st X+, R16	; , 8,1
;2800 /
ldi R16, 16	;
st X+, R16	; , 8,8
;3000 /
ldi R16, 15	;
st X+, R16	; , 9,5
;3500 /
ldi R16, 14	;
st X+, R16	; , 10,2
;3900 /
ldi R16, 12	;
st X+, R16	; , 11,6
;4200 /
ldi R16, 10	;
st X+, R16	; , 13
;4700 /
ldi R16, 8	;
st X+, R16	; , 14,4
;5100 /
ldi R16, 7	;
st X+, R16	; , 15,1
;5600 /
ldi R16, 6	;
st X+, R16	; , 15,8
;6100 /
ldi R16, 5	;
st X+, R16	; , 16,5
;6500 /
ldi R16, 3	;
st X+, R16	; , 17,9
;6900 /
ldi R16, 2	;
st X+, R16	; , 18,6
;7300 /
ldi R16, 1	;
st X+, R16	; , 19,3
;7800 /
ldi R16, 0	;
st X+, R16	; , 20
;8300 /
ldi R16, 0	;
st X+, R16	; , 20
;9000 /
ldi R16, 0	;
st X+, R16	; , 20
;9700 /
ldi R16, 254	;
st X+, R16	; , 20,7
;10600 /
ldi R16, 253	;
st X+, R16	; , 21,4
;11700 /
ldi R16, 252	;
st X+, R16	; , 22,1
;13000 /
ldi R16, 251	;
st X+, R16	; , 22,8
;14600 /
ldi R16, 250	;
st X+, R16	; , 23,5
;16700 /
ldi R16, 249	;
st X+, R16	; , 24,2
;19500 /
ldi R16, 180	;
st X+, R16	; , 24,2
ret		;  

;== 2,   ==
;=======  20,  0.7=======
FuozTable2:
ldi R27, 0x02	; "highX"=02
ldi R26, 0x00	; "lowX"=00
;  
;500  , /
ldi R16, 30	;
st X+, R16	; , -1
;600 /
ldi R16, 28	;
st X+, R16	; , 0,4
;800 /
ldi R16, 27	;
st X+, R16	; , 1,1
;1000 /
ldi R16, 26	;
st X+, R16	; , 1,8
;1200 /
ldi R16, 24	;
st X+, R16	; , 3,2
;1500 /
ldi R16, 21	;
st X+, R16	; , 5,3
;1800 /
ldi R16, 20	;
st X+, R16	; , 6
;2000 /
ldi R16, 18	;
st X+, R16	; , 7,4
;2200 /
ldi R16, 18	;
st X+, R16	; , 7,4
;2500 /
ldi R16, 17	;
st X+, R16	; , 8,1
;2800 /
ldi R16, 16	;
st X+, R16	; , 8,8
;3000 /
ldi R16, 15	;
st X+, R16	; , 9,5
;3500 /
ldi R16, 14	;
st X+, R16	; , 10,2
;3900 /
ldi R16, 12	;
st X+, R16	; , 11,6
;4200 /
ldi R16, 10	;
st X+, R16	; , 13
;4700 /
ldi R16, 8	;
st X+, R16	; , 14,4
;5100 /
ldi R16, 7	;
st X+, R16	; , 15,1
;5600 /
ldi R16, 6	;
st X+, R16	; , 15,8
;6100 /
ldi R16, 5	;
st X+, R16	; , 16,5
;6500 /
ldi R16, 3	;
st X+, R16	; , 17,9
;6900 /
ldi R16, 2	;
st X+, R16	; , 18,6
;7300 /
ldi R16, 1	;
st X+, R16	; , 19,3
;7800 /
ldi R16, 0	;
st X+, R16	; , 20
;8300 /
ldi R16, 0	;
st X+, R16	; , 20
;9000 /
ldi R16, 0	;
st X+, R16	; , 20
;9700 /
ldi R16, 0	;
st X+, R16	; , 20
;10600 /
ldi R16, 0	;
st X+, R16	; , 20
;11700 /
ldi R16, 0	;
st X+, R16	; , 20
;13000 /
ldi R16, 0	;
st X+, R16	; , 20
;14600 /
ldi R16, 0	;
st X+, R16	; , 20
;16700 /
ldi R16, 0	;
st X+, R16	; , 20
;19500 /
ldi R16, 180	;
st X+, R16	; , 20
ret		;  

;== 3,   ==
;=======  20,  0.7=======
FuozTable3:
ldi R27, 0x03	; "highX"=03
ldi R26, 0x00	; "lowX"=00
;  
;500  , /
ldi R16, 0	;
st X+, R16	; , 20
;600 /
ldi R16, 0	;
st X+, R16	; , 20
;800 /
ldi R16, 0	;
st X+, R16	; , 20
;1000 /
ldi R16, 0	;
st X+, R16	; , 20
;1200 /
ldi R16, 0	;
st X+, R16	; , 20
;1500 /
ldi R16, 0	;
st X+, R16	; , 20
;1800 /
ldi R16, 0	;
st X+, R16	; , 20
;2000 /
ldi R16, 0	;
st X+, R16	; , 20
;2200 /
ldi R16, 0	;
st X+, R16	; , 20
;2500 /
ldi R16, 0	;
st X+, R16	; , 20
;2800 /
ldi R16, 0	;
st X+, R16	; , 20
;3000 /
ldi R16, 0	;
st X+, R16	; , 20
;3500 /
ldi R16, 0	;
st X+, R16	; , 20
;3900 /
ldi R16, 0	;
st X+, R16	; , 20
;4200 /
ldi R16, 0	;
st X+, R16	; , 20
;4700 /
ldi R16, 0	;
st X+, R16	; , 20
;5100 /
ldi R16, 0	;
st X+, R16	; , 20
;5600 /
ldi R16, 0	;
st X+, R16	; , 20
;6100 /
ldi R16, 0	;
st X+, R16	; , 20
;6500 /
ldi R16, 0	;
st X+, R16	; , 20
;6900 /
ldi R16, 0	;
st X+, R16	; , 20
;7300 /
ldi R16, 0	;
st X+, R16	; , 20
;7800 /
ldi R16, 0	;
st X+, R16	; , 20
;8300 /
ldi R16, 0	;
st X+, R16	; , 20
;9000 /
ldi R16, 0	;
st X+, R16	; , 20
;9700 /
ldi R16, 0	;
st X+, R16	; , 20
;10600 /
ldi R16, 0	;
st X+, R16	; , 20
;11700 /
ldi R16, 0	;
st X+, R16	; , 20
;13000 /
ldi R16, 0	;
st X+, R16	; , 20
;14600 /
ldi R16, 0	;
st X+, R16	; , 20
;16700 /
ldi R16, 0	;
st X+, R16	; , 20
;19500 /
ldi R16, 0	;
st X+, R16	; , 20
ret		;  
